<?php
namespace Teknisa\DF\Controllers;

use Fiscal;
use Fiscal\Logic\ErrosAvisosNF\ErrosAvisosNF;
use Teknisa\DF\Services\Ger03900ErrosAvisosNFService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;

class Ger03400ReplicacaoDocumentosController extends \Teknisa\DF\Controllers\TeknisaCrud {

	protected $dataSourceName;
    protected $parameterBagColumns; 
    protected $crudService;
    
    public function __construct($crudService) {
        $this->crudService = $crudService;
        
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        if($dataSource === "replicdoc_tipooperac") {
            $this->parameterBagColumns = array("CDFILIAL");
        }
        else if($dataSource === "filial_emprcntrfil") {
            $this->parameterBagColumns = array("P_CDFILIAL", "P_CDEMPRESA");
        }
        else {
            
            $this->parameterBagColumns = array("CDFILIAL", "NRREPLICDOC");
        }
        
        $this->dataSourceName = $dataSource;
       
        parent::find($request, $response);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        $rota = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()) - 6);
        $data = explode("_", $rota);
        $dataSourceNameToSave = $data[0];
        $this->dataSourceNameToSave = $dataSourceNameToSave;
    
        parent::save($request, $response);
    }
    
     public function delete(DTO\Request $request, DTO\Response $response) {
        
        try{
            $rota = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()) - 8);
            $data = explode("_", $rota);
            $dataSource = $data[0];
            
            
            if($dataSource === 'replicdoc') {
                $cdfilial = $request->getRow()['CDFILIAL'];
                $nrreplicdoc = $request->getRow()['NRREPLICDOC'];
                $dataSourceItr = 'itreplicdoc';
                $conditions = array(
        	        array(
            	        "value" => $cdfilial,
            	        "operator" => "=",
            	        "columnName" => "CDFILIAL"
            	      ),
        	       array(
        	            "value" => $nrreplicdoc,
        	            "operator" => "=",
            	        "columnName" => "NRREPLICDOC"
            	      )
    	        );
                $filterCriteria = new FilterCriteria($dataSourceItr, $conditions);
                $this->crudService->find($response, $filterCriteria);
                
                $dataSet = new DataSet($dataSourceItr, $response->getDataSets()[0]->getRows());
                
                $this->crudService->delete($response, $dataSet);
                //Deleta Registros filhos
            }
            
            $this->dataSourceName = $dataSource;
            parent::delete($request, $response);
        }
        catch(\Exception $e) {
            $response->setError(new Error("Error in data save. ".$e->getMessage(), 500));
        }
    }

    
    

}